import java.lang.*;
import java.util.*;
import java.util.regex.*;

class NoteParser
{
	
	public static ArrayList NewNotes;
	
	
	public class Note
	{
		
		public Note (String Name,long NoteDuration)
		{
			this.NoteName=Name;
			this.Duration=NoteDuration;
			
		}
		
		public String NoteName;
		
		//Millisecond duration
		public long Duration;

	}
	public  NoteParser(String OldNotation,int DefaultDuration)
	{
	
		NewNotes=GenerateNote(StringDeleteHeader(OldNotation),DefaultDuration);
		ControlParsing();
		
	
	}
	private String StringDeleteHeader(String OldNotation)
	{
		String NewNotation="";
		String Header="";
		String Line=null;
		while(true)
		{
			
			if(Line !=null)
			{
					if((Line.trim().charAt(1)==':' &&  Character.isUpperCase(Line.trim().charAt(0)) ) || Line.trim().charAt(0)=='%' )	
					{
					}	
					else
					{
						OldNotation=Line+OldNotation;
						break;
					}
			}
			
			Line = OldNotation.substring(0,OldNotation.indexOf('\n'));
			
			OldNotation=OldNotation.substring(OldNotation.indexOf('\n')+1,OldNotation.length());		
				
			Header+=Line;
					
		}
			
		return OldNotation;
	}
	
	private ArrayList GenerateNote(String AbcNote,long DefaultDuration)
	{
		ArrayList MyNewNoteList =new ArrayList();
		char MyChar=0;
		char Prev=0;
		char Next=0;
		char NextNext=0;
	
		Integer Tmp ;
		
		
		
		
		//Cancello tutti i caratteri che non mi servono
		AbcNote=AbcNote.replace('^',' ');
		AbcNote=AbcNote.replace('\'',' ');
		AbcNote=AbcNote.replace('_',' ');
		AbcNote=AbcNote.replace('=',' ');
		AbcNote=AbcNote.replace('[',' ');
		AbcNote=AbcNote.replace(']',' ');
		AbcNote=AbcNote.replace(',',' ');
		
		String patternStr = " ";
        String replaceStr = "";
        Pattern pattern = Pattern.compile(patternStr);
        Matcher matcher = pattern.matcher(AbcNote);
        AbcNote=matcher.replaceAll(replaceStr);
		String tmpstring ="";
		//System.out.println("La stringa dopo il replace "+AbcNote);
		
		
		//Elimino le note tra doppi apici
		for(int i=0;i<AbcNote.length();++i)
		{
			MyChar = AbcNote.charAt(i);
		
		
			if(MyChar=='"')
			{
				do
				{
					i++;
				}
				while( AbcNote.charAt(i)!='"');
			}
			else
			tmpstring+=(new Character(MyChar)).toString();
		}
		//System.out.println("La stringa tmp strim vale ");
		//System.out.println(tmpstring);
		
		AbcNote=tmpstring;
;		//Setto le note
		for(int i=0;i<AbcNote.length();++i)
		{
			MyChar = AbcNote.charAt(i);
			
			
			if(i!=0)
			{
				Prev=AbcNote.charAt(i-1);
			}
			
			if(i<AbcNote.length()-1)
			{
				Next=AbcNote.charAt(i+1);
				
			}
			
			if(i<(AbcNote.length()-2))
			{
				NextNext=AbcNote.charAt(i+2);
			}
			
			if(Character.isLetter(MyChar))
			{
				if(Character.isUpperCase(MyChar) )
						MyChar=Character.toLowerCase(MyChar);
			
						long NoteDuration=GenerateDuration(DefaultDuration,Next,NextNext,Prev);
					switch (MyChar)
					{
	 			    	case 'a': MyNewNoteList.add(new Note("LA",NoteDuration));
	    						  break;
	    				
	    				case 'b': MyNewNoteList.add(new Note("SI",NoteDuration));
	    						  break;
	
	    				case 'c': MyNewNoteList.add(new Note("DO",NoteDuration));
	    						  break;
	    				
	    				case 'd': MyNewNoteList.add(new Note("RE",NoteDuration));
	    						  break;
	    						  
	    				case 'e': MyNewNoteList.add(new Note("MI",NoteDuration));
	    						  break;
	    				
	    				case 'f': MyNewNoteList.add(new Note("FA",NoteDuration));
	    						  break;
	    					
	    				case 'g': MyNewNoteList.add(new Note("SOL",NoteDuration));
	    						  break;
	    						  
	    				case 'z': MyNewNoteList.add(new Note("PAUSE",NoteDuration));
	    						  break;
	    			
					}//end switch
				}//end if
						
			}//fine for
		
		return MyNewNoteList;
	}
	
	long GenerateDuration(long DefaultDuration,char NextChar, char NextNext,char  PreviousChar)
	{
		
		
		if(NextChar=='<')
			return DefaultDuration/2;
			
		if(NextChar=='>')
			return DefaultDuration*2;
		
		if(Character.isDigit(NextChar))
		{
			return (new Integer(Character.toString(NextChar))).longValue() * DefaultDuration;
		}
		
		if(NextChar=='/')
		{
			if(!Character.isDigit(NextNext))
				return DefaultDuration / 2;
				else
				return DefaultDuration / (new Integer(Character.toString(NextNext))).longValue();
		}
		
		
		if(PreviousChar=='>')
			return DefaultDuration/2;
			
		if(PreviousChar=='<')
			return DefaultDuration*2;
			
			
		return DefaultDuration;
	}
	
	void ControlParsing()
	{
		//System.out.println("Le note sono "+String.valueOf(NewNotes.size()));
	
		for(int i=0;i<this.NewNotes.size();++i)
		{
			System.out.println(((Note)NewNotes.get(i) ).NoteName + "\t" +String.valueOf(((Note)NewNotes.get(i) ).Duration));
		}
		
	
	
		SolControl sc=new SolControl(NewNotes);
	}
	
	

}
