
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 import java.io.*;
 
public class SettingFrame extends JFrame
                                     
{
	
	static private JPanel statusArea =new JPanel();
    static private JLabel status =new JLabel();
    final static public String FILE_NAME="key.conf";
    final static public int NUM_BUTTONS=8;
    final private int NUM_KEY_LETTER=26;
	private Container contentPane= getContentPane();
	
	//dialog component
	private JDialog dialog =new JDialog(this,"Error",true);
	private JPanel buttonsPanel =new JPanel();
	private JButton okButton =new JButton("OK");
	private JLabel errorLabel =new JLabel("ERROR: every notes must have different keys");
	private int indexkeyErr;

   	private ButtonGroup bGroup = new ButtonGroup();
   	private ButtonGroup keyboardGroup = new ButtonGroup();
   
   	
   	//Notes components
    private JToggleButton[] buttons = new JToggleButton[]{
    	new JToggleButton("D O "),
    	new JToggleButton("R E "),
    	new JToggleButton("M I "),
    	new JToggleButton("F A "),
    	new JToggleButton("S O L"),
    	new JToggleButton("L A "),
    	new JToggleButton("S I "),
    	new JToggleButton("PAUSE"),
    	};
    	
    //Key components
    private JToggleButton[] keyboardButtons = new JToggleButton[]{
    	new JToggleButton("Q"),
    	new JToggleButton("W"),
    	new JToggleButton("E"),
    	new JToggleButton("R"),
    	new JToggleButton("T"),
    	new JToggleButton("Y"),
    	new JToggleButton("U"),
    	new JToggleButton("I"),
    	new JToggleButton("O"),
    	new JToggleButton("P"),
    	new JToggleButton("A"),
    	new JToggleButton("S"),
    	new JToggleButton("D"),
    	new JToggleButton("F"),
    	new JToggleButton("G"),
    	new JToggleButton("H"),
    	new JToggleButton("J"),
    	new JToggleButton("K"),
    	new JToggleButton("L"),
    	new JToggleButton("Z"),
    	new JToggleButton("X"),
    	new JToggleButton("C"),
    	new JToggleButton("V"),
    	new JToggleButton("B"),
    	new JToggleButton("N"),
    	new JToggleButton("M"),
    	};
    	
    Box box = Box.createHorizontalBox();
  
    
	Box keyboardBox = Box.createHorizontalBox();
    
    public static String[]  keyLabel= {"DO","RE","MI","FA","SOL","LA","SI","PAUSE"};
   	String[]  keyConf = new String[8];
    JLabel[] keyConfLabel = new JLabel[8];
    	 	
    public SettingFrame()
    {
  		setLayout(null);
  
  		//Load configuration from file
  	    this.loadConfiguration();
  	    
  	    
  	    
  	    //dialog configuration
  	    dialogConfig();
  	   
  	   
  	   
  	   
  	   
  	    JButton applyButton = new JButton("Apply");
	  	JButton cancelButton = new JButton("Cancel");

		
	  	
	  	
		
  		coloredPanel opaque = new coloredPanel();
  		opaque.setLayout(null);
  		opaque.add(applyButton);
  		opaque.add(cancelButton);

  		
  	    
 		
 		opaque.add(keyboardBox);
 		
 		keyboardBox.setBounds(10,10,650,40);
 		
 		
  		for(int i=0;i<NUM_KEY_LETTER;i++)
  		{
  			if(i<10)
  			{
  				opaque.add(keyboardButtons[i]);
  				keyboardBox.add(Box.createHorizontalStrut(5));
  				keyboardGroup.add(keyboardButtons[i]);
  				keyboardButtons[i].setBounds(10+(i*50),20,47,30);
  			}
  			if(i>=10 && i<19)
  			{
  				opaque.add(keyboardButtons[i]);
  				keyboardBox.add(Box.createHorizontalStrut(5));
  				keyboardGroup.add(keyboardButtons[i]);
  				keyboardButtons[i].setBounds(20+((i-10)*50),60,47,30);
  			}
  			if(i>=19)
  			{
  				opaque.add(keyboardButtons[i]);
  				keyboardBox.add(Box.createHorizontalStrut(5));
  				keyboardGroup.add(keyboardButtons[i]);
  				keyboardButtons[i].setBounds(30+((i-19)*50),100,47,30);
  			}
  			
  		}
  		
  		applyButton.setBounds(345,180,80,20);
  		cancelButton.setBounds(435,180,80,20);
  		
  	
  		
  		
  		this.add(opaque);
  		

  		opaque.setBounds(50,90,650,300);
  		
  		
    	this.setResizable(false);
    	
    	
    	
    	
    	
    	box.setBounds(0,10,700,40);

    	for(int i=0;i<buttons.length;++i)
  		{
  			keyConfLabel[i]=new JLabel(keyConf[i]);
  			this.add(keyConfLabel[i]);
  			
  			bGroup.add(buttons[i]);
  			box.add(Box.createHorizontalStrut(18));
  			box.add(buttons[i]);
  		
		}
		
		keyConfLabel[0].setBounds(40,50,20,20);
		keyConfLabel[1].setBounds(115,50,20,20);
		keyConfLabel[2].setBounds(190,50,20,20);
		keyConfLabel[3].setBounds(260,50,20,20);
		keyConfLabel[4].setBounds(335,50,20,20);
		keyConfLabel[5].setBounds(415,50,20,20);
		keyConfLabel[6].setBounds(485,50,20,20);
		keyConfLabel[7].setBounds(565,50,20,20);
			
  			buttons[0].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[0].getText()))
					{
						

						keyboardButtons[findIndexButton(keyConf[0])].setSelected(true);
						//msgLabel.setForeground(Color.black);
						//msgLabel.setText("Stroke any key to change the  "+buttons[0].getText()+"  note");
						//confMsgLabel.setText("The actual configuration of  "+buttons[0].getText()+" is");
						//confLabel.setFont(new Font("Arial",Font.BOLD,30));
						//confLabel.setForeground(Color.red);
						//confLabel.setText("  "+keyConf[0]);
					}
    			}
    		
    		});
    		
   		
   			buttons[1].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[1].getText()))
					{
						keyboardButtons[findIndexButton(keyConf[1])].setSelected(true);
						/*
						msgLabel.setForeground(Color.black);
						msgLabel.setText("Stroke any key to change the  "+buttons[1].getText()+"  note");
						confMsgLabel.setText("The actual configuration of  "+buttons[1].getText()+" is");
						confLabel.setFont(new Font("Arial",Font.BOLD,30));
						confLabel.setForeground(Color.red);
						confLabel.setText("  "+keyConf[1]);*/
					}
    			}
    		
    		});
   		
   		
 			buttons[2].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[2].getText()))
					{
						keyboardButtons[findIndexButton(keyConf[2])].setSelected(true);
						/*
						msgLabel.setForeground(Color.black);
						msgLabel.setText("Stroke any key to change the  "+buttons[2].getText()+"  note");
						confMsgLabel.setText("The actual configuration of  "+buttons[2].getText()+" is");
						confLabel.setFont(new Font("Arial",Font.BOLD,30));
						confLabel.setForeground(Color.red);
						confLabel.setText("  "+keyConf[2]);
						*/
					}
    			}
    		
    		});
    		
    		
   			buttons[3].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[3].getText()))
					{
						keyboardButtons[findIndexButton(keyConf[3])].setSelected(true);
						/*
						msgLabel.setForeground(Color.black);
						msgLabel.setText("Stroke any key to change the  "+buttons[3].getText()+"  note");
						confMsgLabel.setText("The actual configuration of  "+buttons[3].getText()+" is");
						confLabel.setFont(new Font("Arial",Font.BOLD,30));
						confLabel.setForeground(Color.red);
						confLabel.setText("  "+keyConf[3]);
						*/
					}
    			}
    		
    		});
    		
    		
   			buttons[4].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[4].getText()))
					{
						keyboardButtons[findIndexButton(keyConf[4])].setSelected(true);
						/*
						msgLabel.setForeground(Color.black);
						msgLabel.setText("Stroke any key to change the  "+buttons[4].getText()+"  note");
						confMsgLabel.setText("The actual configuration of  "+buttons[4].getText()+" is");
						confLabel.setFont(new Font("Arial",Font.BOLD,30));
						confLabel.setForeground(Color.red);
						confLabel.setText("  "+keyConf[4]);
						*/
					}
    			}
    		
    		});
    		
    		
   			buttons[5].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[5].getText()))
					{
						keyboardButtons[findIndexButton(keyConf[5])].setSelected(true);
						/*
						msgLabel.setForeground(Color.black);
						msgLabel.setText("Stroke any key to change the  "+buttons[5].getText()+"  note");
						confMsgLabel.setText("The actual configuration of  "+buttons[5].getText()+" is");
						confLabel.setFont(new Font("Arial",Font.BOLD,30));
						confLabel.setForeground(Color.red);
						confLabel.setText("  "+keyConf[5]);
						*/
					}
    			}
    		
    		});
    		
    		
   			buttons[6].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[6].getText()))
					{
						keyboardButtons[findIndexButton(keyConf[6])].setSelected(true);
						/*
						msgLabel.setForeground(Color.black);
						msgLabel.setText("Stroke any key to change the  "+buttons[6].getText()+"  note");
						confMsgLabel.setText("The actual configuration of  "+buttons[6].getText()+" is");
						confLabel.setFont(new Font("Arial",Font.BOLD,30));
						confLabel.setForeground(Color.red);
						confLabel.setText("  "+keyConf[6]);
						*/
					}
    			}
    		
    		});
    		
    		buttons[7].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(buttons[7].getText()))
					{
						keyboardButtons[findIndexButton(keyConf[7])].setSelected(true);
						/*
						msgLabel.setForeground(Color.black);
						msgLabel.setText("Stroke any key to change the  "+buttons[6].getText()+"  note");
						confMsgLabel.setText("The actual configuration of  "+buttons[6].getText()+" is");
						confLabel.setFont(new Font("Arial",Font.BOLD,30));
						confLabel.setForeground(Color.red);
						confLabel.setText("  "+keyConf[6]);
						*/
					}
    			}
    		
    		});
    		
    		
    		
    		keyboardButtons[0].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[0].getText()))
					{
						//If the exist two equal keys in the configuration and I am not clicking the current key
						if(existButton(keyboardButtons[0].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[0].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[0].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		
    	
    		
    		keyboardButtons[1].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[1].getText()))
					{
							//If the exist two equal keys in the configuration and I am not clicking the current key
						if(existButton(keyboardButtons[1].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[1].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[1].getText();
							
							update_keyConf();
						}
					}
    			}
    		
    		});
    		
    		keyboardButtons[2].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[2].getText()))
					{
							//If the exist two equal keys in the configuration and I am not clicking the current key
						if(existButton(keyboardButtons[2].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[2].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[2].getText();
							
							update_keyConf();
						}
					}
    			}
    		
    		});
    		
    		keyboardButtons[3].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[3].getText()))
					{
							//If the exist two equal keys in the configuration and I am not clicking the current key
						if(existButton(keyboardButtons[3].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[3].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[3].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[4].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[4].getText()))
					{
							//If the exist two equal keys in the configuration and I am not clicking the current key
						if(existButton(keyboardButtons[4].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[4].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[4].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[5].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[5].getText()))
					{
							//If the exist two equal keys in the configuration and I am not clicking the current key
						if(existButton(keyboardButtons[5].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[5].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[5].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[6].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[6].getText()))
					{
							//If the exist two equal keys in the configuration and I am not clicking the current key
						if(existButton(keyboardButtons[6].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[6].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[6].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[7].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[7].getText()))
					{
						if(existButton(keyboardButtons[7].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[7].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[7].getText();
							
							update_keyConf();
						}
					}
    			}
    		
    		});
    		
    		keyboardButtons[8].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[8].getText()))
					{
						if(existButton(keyboardButtons[8].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[8].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[8].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[9].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[9].getText()))
					{
						if(existButton(keyboardButtons[9].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[9].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[9].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[10].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[10].getText()))
					{
						if(existButton(keyboardButtons[10].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[10].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[10].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[11].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[11].getText()))
					{
						if(existButton(keyboardButtons[11].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[11].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[11].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[12].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[12].getText()))
					{
						if(existButton(keyboardButtons[12].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[12].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[12].getText();
							
							update_keyConf();
						}						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[13].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[13].getText()))
					{
						if(existButton(keyboardButtons[13].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[13].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[13].getText();
							
							update_keyConf();
						}
					}
    			}
    		
    		});
    		
    		keyboardButtons[14].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[14].getText()))
					{
						if(existButton(keyboardButtons[14].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[14].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
					else
						{
							keyConf[findButtonPressed()]=keyboardButtons[14].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[15].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[15].getText()))
					{
						if(existButton(keyboardButtons[15].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[15].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[15].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[16].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[16].getText()))
					{
						if(existButton(keyboardButtons[16].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[16].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[16].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[17].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[17].getText()))
					{
						if(existButton(keyboardButtons[17].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[17].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[17].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[18].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[18].getText()))
					{
						if(existButton(keyboardButtons[18].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[18].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[18].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		keyboardButtons[19].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[19].getText()))
					{
						if(existButton(keyboardButtons[19].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[19].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[19].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    			keyboardButtons[20].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[20].getText()))
					{
						if(existButton(keyboardButtons[20].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[20].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[20].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    			keyboardButtons[21].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[21].getText()))
					{
						if(existButton(keyboardButtons[21].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[21].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[21].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    				keyboardButtons[22].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[22].getText()))
					{
						if(existButton(keyboardButtons[22].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[22].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[22].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    				keyboardButtons[23].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[23].getText()))
					{
						if(existButton(keyboardButtons[23].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[23].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[23].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    				keyboardButtons[24].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[24].getText()))
					{
						if(existButton(keyboardButtons[24].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[24].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[24].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    				keyboardButtons[25].addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(keyboardButtons[25].getText()))
					{
						if(existButton(keyboardButtons[25].getText()) && !keyConf[findButtonPressed()].equals(keyboardButtons[25].getText()))
						{
							dialog.show();
							keyboardButtons[indexOfKey(keyConf[findButtonPressed()])].setSelected(true);
						}
						else
						{
							keyConf[findButtonPressed()]=keyboardButtons[25].getText();
							
							update_keyConf();
						}
						 
					}
    			}
    		
    		});
    		
    		
    		
    		
    		
    		
    	cancelButton.addActionListener(new ActionListener()
    	{
    		public void actionPerformed(ActionEvent e)
    		{
    			if(e.getActionCommand().equals("Cancel"))
				{
    				dispose();
  
 		   			Sol.isActiveSetting = false;
 		   		}
    		}
    		
    	});
    	
    	applyButton.addActionListener(new ActionListener()
    	{
    		public void actionPerformed(ActionEvent e)
    		{
    			if(e.getActionCommand().equals("Apply"))
				{
    				saveConfiguration();
 		   		}
    		}
    		
    	});
  		
  	
   			 		
  		box.add(Box.createHorizontalStrut(5));
  		contentPane.add(box);
  	

		
    }
    
    
 

	public static void launch(final JFrame f,String title,final int x,final int y,final int w,int h)
    {
    	f.setTitle(title);
    	f.setBounds(x,y,w,h);
    	f.setVisible(true);
    	statusArea.setBorder(BorderFactory.createEtchedBorder());
    	statusArea.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
    	statusArea.add(status);
    	status.setHorizontalAlignment(JLabel.LEFT);
    	f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	
    	f.addWindowListener(new WindowAdapter(){
    		public void windowClosed(WindowEvent e)
    		{
    			f.setVisible(false);
  
    			Sol.isActiveSetting = false;
    		}
    	});
  		 	
    }
    
    
    public void loadConfiguration()
    {
    	
      int i=0;
      	
      try
      {	
      	FileInputStream fstream = new FileInputStream(FILE_NAME);
      
     	 DataInputStream in = new DataInputStream(fstream);

      	while (in.available() !=0)
				{
					keyConf[i]=(in.readLine());
					i++;
				}

			in.close();
		}
		catch (Exception e)
			{
				System.err.println(e.getMessage());
			}
    }
    
    private void saveConfiguration()
    {
    	FileOutputStream out;
        PrintStream p;

                try
                {
                        out = new FileOutputStream(FILE_NAME);

                        p = new PrintStream( out );
		
						for(int i=0;i<NUM_BUTTONS;i++)
                        	p.println (keyConf[i]);

                        p.close();
                }
                catch (Exception e)
                {
                        System.err.println ("Error writing to file");
                }	
                
    
    }
private void dialogConfig()
{
	 Container dialogContentPane= dialog.getContentPane();
  	   	dialogContentPane.setLayout(null);
  	   
  	    dialogContentPane.add(errorLabel);
  	    errorLabel.setBounds(10,10,300,30);
  	    
  	    dialogContentPane.add(okButton);
  	    okButton.setBounds(200,45,80,20);  	   
  	    dialog.pack();
  	   	dialog.setBounds(550,380,300,100);
 		dialog.setResizable(false);
 		
  	   	okButton.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(okButton.getText()))
					{
							
						dialog.hide();
						
					}
    			}
    		
        });
        
}

private void update_keyConf()
{
	for(int i=0;i<NUM_BUTTONS;i++)
	{
		keyConfLabel[i].setText(keyConf[i]);
	}
	
}

private int indexOfKey(String key) 
{
	
	for(int i=0;i<NUM_KEY_LETTER;++i )
	{
		if(key.equals(keyboardButtons[i].getText()))
			return i;
	}
	return 0;
}



private int findIndexButton(String note)
{
	
	for(int i=0;i<NUM_KEY_LETTER;++i )
	{
		if(note.equals(keyboardButtons[i].getText()))
			return i;
	}
	return 0;
}

private int findButtonPressed()
{
	
	for(int i=0;i<NUM_BUTTONS;++i )
	{
		if(buttons[i].isSelected())
			return i;
	}
	return 0;
}

private boolean existButton(String key)
{
	for(int i=0;i<NUM_BUTTONS;++i)
	{
		if(keyConf[i].equals(key))
		 return true;
	}
	return false;
}

class coloredPanel extends JPanel
{
	
  	public void paintComponent(Graphics g)	
	{
	   
		super.paintComponent(g);
		g.setColor(Color.black);
		g.drawRect(5,10,520,200);
		
		
		
	}

}



}