 import java.awt.*;
 import java.awt.geom.*;
 import javax.imageio.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 import java.io.*;
 import abc.notation.Tune;
 import abc.ui.swing.TuneBookTable;
 import abc.parser.TuneBook;
 import java.util.StringTokenizer; 
 import java.net.*;
 import java.awt.Toolkit.*;
 import javax.swing.table.*;
 import abc.midi.*;
 import abc.notation.KeySignature;
 import javax.sound.midi.*;

public class Sol extends JFrame  {

	//File info trasformazione jpeg
	final public static String FILE_PATH_TMP="tmp.txt";
	final public static String NAME_PAGE="Page ";
	final public static String  TOTAL_PAGE=" of ";
	final public static String IMAGE_FORMAT=".jpg";
	
	//Componenete che permette il browsing dei file
    JFileChooser chooser =new JFileChooser();
    
    //varibili di hiding dei frame
    static boolean isActiveSetting = false;
    static boolean isActiveSelectTune= false;
   	
   	//immagini dello spartito
  	public ImageIcon[] MyImage;
   	public JLabel[] MyImageLabel;
   	
   	  
    //controllo aperturafile
	boolean IsFileOpen=false;
	
	//indice immagini
	public static int ImageIndex=0;
	public static int ImageNumber=0;
	
	//componenti menu
	Container contentPane;
   	JPanel panel=new JPanel();
    JMenuBar mb =new JMenuBar();
    JMenu fileMenu =new JMenu("File");
    JMenu optionMenu =new JMenu("Option");
    JMenuItem openItem =new JMenuItem("Open");
    JMenuItem exitItem =new JMenuItem("Exit");	
    JMenuItem settingItem =new JMenuItem("Setting");
   	
  
   	//Componenti leggio 
   	public  JScrollPane scroll=null;
   	public static JButton Bavanti=new JButton("Next");
   	public static JButton Bindietro=new JButton("Previous");
   	
   	//Componenti solfeggio 
   	public static JButton BstartSolfeggio=new JButton("START");
   	public static JButton BstopSolfeggio=new JButton("STOP");
   	public static JButton BreportSolfeggio=new JButton("REPORT");
	public static SolControl SolController=null;
   	long TBegin=0;
    boolean IsFirst=true;
    public static boolean SolfeggioEnabled=false;
    public static ReportFrame FrameReport;
   	int NumberKeyPressed=0;
   	
   	//Componenti player
   	public static JButton BplayTune=new JButton("PLAY");
   	public static JButton BstopTune=new JButton("STOP");
	public static JButton BpauseTune=new JButton("PAUSE");
	
	//Componenti key sound
	KeySound MyKS=new KeySound();
   	
   	
	public JLabel LPageNum=new JLabel();
	public static JLabel LNotePlayed=new JLabel("",JLabel.CENTER);
	public JLabel LSelectPage=new JLabel("SELECT PAGE");
	public JLabel LSolfeggio=new JLabel("SOLFEGGIO");
	public JLabel LPlayTune=new JLabel("PLAY TUNE");
	public JLabel LNoteStroken =new JLabel("",JLabel.CENTER);
	public JLabel LCorrectness =new JLabel("",JLabel.CENTER);
	public static JLabel LMark=new JLabel("",JLabel.CENTER);
	
	
	
   	//Frame iniziale
   	public static Sol FrameSol=new Sol();
   	
   	//Frame settaggio tasti
   	public static SettingFrame SolSetting =new SettingFrame();
   	
   	
   	//
   	public static AbcPlayer myap; 
   	
    public Sol()
    {
    	
		contentPane = getContentPane();

		//Aggiungo il menu
		AddMenu();
	
		//Add Label
		AddLabel();
		
		//Add button
		AddButton();
	
		
		
		MyKS.setPriority(java.lang.Thread.MAX_PRIORITY);
		//Faccio partire il thread che suona la nota premuta
  	    MyKS.start();
  	    
		setLayout(null);
		
		
		
	
	
	
		

		//Setting scroll
		scroll=new JScrollPane();
		scroll.setBounds(0,0,900,700);
		add(scroll);
		
	
		
		//Aggiungo un listener per i tasti
		this.addKeyListener(new MyKeyListener());
    
    
		
		
		
		
		Bavanti.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(Bavanti.getText()))
					{
					
							++ImageIndex;
							LPageNum.setText(NAME_PAGE+String.valueOf(ImageIndex+1)+TOTAL_PAGE+String.valueOf(ImageNumber));
	
						scroll.getViewport().setView(new JLabel(MyImage[ImageIndex]));
					
						if(ImageIndex==(ImageNumber-1))
							Bavanti.setEnabled(false);
						
						if(ImageIndex>=1)
							Bindietro.setEnabled(true);
							else
							Bindietro.setEnabled(false);
						
						
								
					}
    			}
    		
    		});
    		
    		
    	Bindietro.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(Bindietro.getText()))
					{

					
						--ImageIndex;
						LPageNum.setText(NAME_PAGE+String.valueOf(ImageIndex+1)+TOTAL_PAGE+String.valueOf(ImageNumber));
						scroll.getViewport().setView(new JLabel(MyImage[ImageIndex]));
						
						if(ImageIndex==0)
							Bindietro.setEnabled(false);
					
						if(ImageIndex>=0)
							Bavanti.setEnabled(true);
						else
							Bavanti.setEnabled(false);
							
						
					}
    			}
    		
    		});
    		
    		
    		
    		BplayTune.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(BplayTune.getText()))
					{		
						BplayTune.setEnabled(false);
						BstopTune.setEnabled(true);
						BpauseTune.setEnabled(true);
						BstartSolfeggio.setEnabled(false);
						LMark.setText("");	
						LCorrectness.setText("");
						if(!myap.isAlive())
						{

							myap.start();
						}
						else
						{
							myap.RestartPlayer();
						}
					}
    			}
    		
    		});
    		
    		
    		BstopTune.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(BstopTune.getText()))
					{
						BplayTune.setEnabled(true);
						BstopTune.setEnabled(false);
						BpauseTune.setEnabled(false);
						BstartSolfeggio.setEnabled(true);
						myap.StopPlayer();
					}
    			}
    		
    		});
    		
    		BpauseTune.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(BpauseTune.getText()))
					{
						requestFocus();
						BplayTune.setEnabled(true);
						BstopTune.setEnabled(true);
						BpauseTune.setEnabled(false);
						myap.PausePlayer();
					}
    			}
    		
    		});
    	
    		
    		
    		BstartSolfeggio.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(BstartSolfeggio.getText()))
					{
						NumberKeyPressed=0;
					 	BstartSolfeggio.setEnabled(false);
					 	BstopSolfeggio.setEnabled(true);
						BplayTune.setEnabled(false);
						BreportSolfeggio.setEnabled(false);
						SolfeggioEnabled=true;
						Sol.SolController.Init();
						Sol.LMark.setText("");
						requestFocus();		
					}
    			}
    		
    		});
    		
    		
    		BstopSolfeggio.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(BstopSolfeggio.getText()))
					{
					
						requestFocus();
						BstartSolfeggio.setEnabled(true);
					 	BstopSolfeggio.setEnabled(false);
					 	BreportSolfeggio.setEnabled(true);
					 	BplayTune.setEnabled(true);
					 	SolfeggioEnabled=false;
					 	TBegin=0;	
					 	IsFirst=true;
					 	LCorrectness.setText("");
					 	LMark.setText("");
								
					}
    			}
    		
    		});
    		
    		
    		BreportSolfeggio.addActionListener(new ActionListener()
    		{
    			public void actionPerformed(ActionEvent e)
    			{
    				
					if(e.getActionCommand().equals(BreportSolfeggio.getText()))
					{
						requestFocus();
						BstartSolfeggio.setEnabled(true);
					 	BstopSolfeggio.setEnabled(false);
					 	BreportSolfeggio.setEnabled(false);
					 	FrameReport=new ReportFrame(Sol.SolController.ReportList);
					 	ReportFrame.launch(FrameReport,"Solfeggio Success");
						
					}
    			}
    		
    		});
    		
		



    	
    		
    		
    		
    		

    	 //adding action listener on openItem
    	openItem.addActionListener(new ActionListener()
    	{
    		public void actionPerformed(ActionEvent e)
    		{
				//chooser.showOpenDialog(null);
				int state= chooser.showOpenDialog(null);
				File file = chooser.getSelectedFile();
				
				if (file != null && state == JFileChooser.APPROVE_OPTION)
				{	
			
				  	try
				  	{
				  		SelectTuneFrame.launch(new SelectTuneFrame(file.getPath()),"Select your favourite tune");
				  	}
				  	catch(Exception ev)
				  	{
						//Mostro un messaggio d'errore
			  			JOptionPane.showMessageDialog(Sol.FrameSol,"Error: the abc file is corrupted!","Error",JOptionPane.ERROR_MESSAGE);

				  	}
			   
			    	
				}			
			
    		}
    		
    	});
    	
    	
    	//adding action listener on exitItem
    	exitItem.addActionListener(new ActionListener()
    	{
    		public void actionPerformed(ActionEvent e)
    		{
    			dispose();
    			System.exit(0);
    		}
    		
    	});
    	
    	//adding action listener on exitItem
    	settingItem.addActionListener(new ActionListener()
    	{
    		public void actionPerformed(ActionEvent e)
    		{
    			 // Create application frame.
        		if(!isActiveSetting)	
        		{
        			SettingFrame.launch(SolSetting,"Setting",400,400,640,350);
        			isActiveSetting = true;
        		}
        		
    		}
    		
    	});

	
    
    }
    

    
    
    public static void main(String[] args)
    {
        
        // Create application frame.
        SolFrame.launch(FrameSol,"Solfeggio",0,0,1240,768);
   
        //introsound();
	}

	
	
	public static  void introsound()
	
	{
		try
		{
		
			Synthesizer syn =MidiSystem.getSynthesizer();
			syn.open();
			MidiChannel[] mc= syn.getChannels();
			mc[15].noteOn(44,200);
			//syn.close();
		}
		catch(Exception e)
		{
			e.printStackTrace();		
		}
	} 
	
	
	//Aggoinge il menu
	private void AddMenu()
	{	
		
		panel.setBorder(BorderFactory.createEtchedBorder());
    	contentPane.add(panel,BorderLayout.CENTER);
    	contentPane.add(SolFrame.getStatusArea(),BorderLayout.SOUTH);
    	SolFrame.showStatus(SolFrame.getResource("statusareatext"));
    	chooser.setFileFilter(new abcFilter());
    	
    	fileMenu.add(openItem);
    	fileMenu.add(exitItem);
    	optionMenu.add(settingItem);
    	mb.add(fileMenu);
    	mb.add(optionMenu);
    	
    	getRootPane().setJMenuBar(mb);
	}
	
	
	private void AddLabel()
	{
		//Setting select page  Label 
		LSelectPage.setBounds(922,20,90,20);
		add(LSelectPage);
		
		//Setting page number Label 
		LPageNum.setBounds(925,130,80,30);
		add(LPageNum);
		
		//Setting Solfeggio Label 
		LSolfeggio.setBounds(927,175,80,30);
		add(LSolfeggio);
		
		//Setting Play Tune Label 
		LPlayTune.setBounds(928,445,80,30);
		add(LPlayTune);
		
		//Setting Note Played labebel
		LNotePlayed.setBounds(905,645,110,30);
		add(LNotePlayed);
		
		//Set stroken label
		LNoteStroken.setBounds(905,360,110,40);
		add(LNoteStroken);
		
		//set correctness label
		LCorrectness.setBounds(905,390,110,40);
		add(LCorrectness);
		
		//set the mak label
		LMark.setBounds(905,380,110,40);
		add(LMark);
		
	}
	
	private void AddButton()
	{
		//Bottoni pagine
		Bavanti.setBounds(910,50,100,20);
		Bindietro.setBounds(910,80,100,20);
		Bavanti.setEnabled(false);
		Bindietro.setEnabled(false);
		this.add(Bavanti);
		this.add(Bindietro);
		
		
		//Bottoni play 	
		BplayTune.setBounds(910,480,100,40);
		BplayTune.setEnabled(false);
		this.add(BplayTune);
		
		BstopTune.setBounds(910,530,100,40);
		BstopTune.setEnabled(false);
		this.add(BstopTune);
		
		BpauseTune.setBounds(910,580,100,40);
		BpauseTune.setEnabled(false);
		this.add(BpauseTune);
		
		
	
		//Bottoni solfeggio
		BstartSolfeggio.setBounds(910,210,100,40);	
		BstartSolfeggio.setEnabled(false);
		this.add(BstartSolfeggio);
		

		BstopSolfeggio.setBounds(910,260,100,40);	
		BstopSolfeggio.setEnabled(false);
		this.add(BstopSolfeggio);
		

		BreportSolfeggio.setBounds(910,310,100,40);	
		BreportSolfeggio.setEnabled(false);
		this.add(BreportSolfeggio);
		
		
		
	}
	
	Image ReadImage(String Path)
	{
		Image image =null;
		try
		{
			File file=new File(Path);
			image=ImageIO.read(file);
		}
		catch(Exception e)
		{
			System.out.println(e.getMessage());
		}
		
		return image;
	}
	

	
	public static int getImageNumber()
	{
		String str="";
		String str_help="";
		//Leggo il file in una stringa
		try 
		{
	        BufferedReader in = new BufferedReader(new FileReader(FILE_PATH_TMP));
	       
        
        while ((str_help = in.readLine()) != null) 
        	str+=str_help;
        
        in.close();
    	}
    	catch (IOException e)
    	{
    		System.out.println(e.getMessage());
    	}
    	
    
    	//utilizzo il tokenizer per estrapolare il numero di immagini generate
    	StringTokenizer st = new StringTokenizer(str);
    	
    	while (st.hasMoreTokens())
      	{
        	try
         	{
         		 String prevword = st.nextToken();
         		 
         		 String actualword =st.nextToken();
         		
         		 if(actualword.equals("pages,") || actualword.equals("page,"))
         		 {
         		 	return  Integer.parseInt(prevword.substring(1));
         		 }
         	}
         	catch(Exception e)
	        {
	        	System.out.println(e.getMessage());
	        }     	
	        
        }
    return -1;   
   }
	
	
	//Carica le immagini
	public void createImages()
	{
		
		//Reinizializzo l'indice dell'immagine
		ImageIndex=0;
		
		Bavanti.setEnabled(false);
		Bindietro.setEnabled(false);
		
		ImageNumber=getImageNumber();
		if(ImageNumber>1)
		{
			Bavanti.setEnabled(true);
			Bindietro.setEnabled(false);
		}
		MyImageLabel=new JLabel [ImageNumber];
		MyImage =new ImageIcon[ImageNumber];
	
		for(int i=1;i<=ImageNumber;++i)
		{ 		
     	   MyImage[i-1] =new ImageIcon (SelectTuneFrame.nome_canzone+String.valueOf(i)+IMAGE_FORMAT);
     	   MyImageLabel[i-1]=new JLabel(MyImage[i-1]);
   		}
	
	

		Sol.FrameSol.scroll.getViewport().setView(MyImageLabel[0]);
		LPageNum.setText(NAME_PAGE+"1"+TOTAL_PAGE+String.valueOf(ImageNumber));
	
	}
	
	


public void paint(Graphics g)
{
	super.paint(g);
	g.drawRect(907,60,113,150);
	g.drawRect(907,220,113,260);
	g.drawRect(907,490,113,240);
}


    //Classe per il controllo del tasto premuto
public class MyKeyListener extends KeyAdapter
{
        long tstart=0;
        long tend=0;
        
       
        boolean charPressed=false;
        NoteKey KeyController = new NoteKey();
        char keypressed;
        char keystroked;
        String NoteStroken=null;
        
        
        public void keyPressed(KeyEvent evt)
        {
        
        keypressed=Character.toUpperCase(evt.getKeyChar());
        	
        	//contollo che premuto un tasto tra quelli configurati
        	if(KeyController.IsAnAvailableKey(keypressed) && SolfeggioEnabled==true)
        	{
        	
        		//contollo che no si staot premuto nessun altro tasto
	        	if(!charPressed)
	        	{
	        		
	        		charPressed=true;
	        		
	        		
	        		if(IsFirst)
	        		{
	        			TBegin=System.currentTimeMillis();
	        			IsFirst=false;
	        			tstart = 0;
	        		}
	        		else
	        		{
	        			//recupero il tempo in cui premo il tasto
	        			tstart = System.currentTimeMillis() - TBegin;
	        		}
	        	
	        		
	        		//Leggo  il tasto premuto
	        		keystroked=evt.getKeyChar();
	        		
	        		//Converto da tast a nota
	        		NoteStroken=KeyController.Key2Note(keypressed);
	        		
	        		//setto il label
	        		if(NoteStroken.equals("PAUSE"))
	        			LNoteStroken.setText(NoteStroken);
	        		else
	        			LNoteStroken.setText("Note Stroken: "+NoteStroken);
	        		
	        		//setto il label
	        		MyKS.SetNote(NoteStroken);
	        		
	        		
	        		
	        	
	        		
	        	}
	       	}
        }
        
        public void keyReleased(KeyEvent evt)
        {    
        
        
        	if(charPressed && keystroked == evt.getKeyChar() && SolfeggioEnabled==true)
        	{
	        //	System.out.println("ho rilasciato "+ String.valueOf(evt.getKeyChar()));
	        	
	        	//recupero il tempo in cui rilascio il tasto
	        	tend = System.currentTimeMillis()-TBegin;
	        	
	        	//cancello il label della nota
	        	LNoteStroken.setText("");
	        	
	        	//fermo il suono
	        	MyKS.StopSound();
	        	
	        	LCorrectness.setText("Success: "+String.valueOf(Sol.SolController.IsCorrectNote(tstart,tend,NoteStroken))+"%");
	    
	           	charPressed=false;
	           	
	           	NumberKeyPressed++;
	           	
	           	
	           	//fermo il solfeggio se l'utente ha rpremuto un numero di tasti uguale al numero delle note
	           	if(Sol.SolController.MyNoteTimes.size()==NumberKeyPressed)
	           	{
           			requestFocus();
					BstartSolfeggio.setEnabled(true);
				 	BstopSolfeggio.setEnabled(false);
				 	BreportSolfeggio.setEnabled(true);
				 	BplayTune.setEnabled(true);
				 	SolfeggioEnabled=false;
				 	TBegin=0;	
				 	IsFirst=true;
				 	
				 	Sol.SolController.CalculateAverage();
				 	LCorrectness.setText("");
				 	LMark.setText(Sol.SolController.MyMark+" "+String.valueOf(Math.round(Sol.SolController.Average))+"%");
				 	
	           	}
	        }
	    }
        
}//fine classe MyKeyListener

}
