import java.util.*;
import java.applet.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.awt.*;
import java.awt.Toolkit.*;
import  sun.audio.*;   
import  java.io.*;



class SolControl
{
	
	final long TOLLERANCE=800;
	public ArrayList MyNoteTimes;
	int MyLastIndexFound=0;
	ArrayList ReportList=new ArrayList();
	public final String[] MyMarks=new String[]{"BAD","NOT ENOUGH","ENOUGH","GOOD","EXCELLENT"};
	public String MyMark="";  
	public float Average=0;
	
	InputStream in;
	AudioStream as;
	
	public class NoteTime
	{
		
		public NoteTime(long Ts,long Te,String N)
		{
			Tstart=Ts;
			Tend=Te;
			Note=N;
		}
		public long Tstart;
		public long Tend;
		String Note;		
	}
	
	public class NoteReport
	{
		
		public NoteReport(int perc,String notename)
		{
			percentage=perc;
			note=notename;
		}
		public int percentage;
		public String note;
	}


private ArrayList Note2NoteTime(ArrayList NoteArray)
{
	
	ArrayList TimesNote=new ArrayList();
	long Scounter=0;
	long Ecounter=0;
	for(int i = 0; i<NoteArray.size(); ++i)
	{
		NoteParser.Note MyNote=(NoteParser.Note)NoteArray.get(i);
		Ecounter+=MyNote.Duration;
		NoteTime NoteDuration=new NoteTime(Scounter,Ecounter,MyNote.NoteName);
			
		Scounter+=MyNote.Duration;
		TimesNote.add(NoteDuration);
	}
	return TimesNote;
}

private void  ContentControl(ArrayList TimesNote)
{
	for(int i = 0; i<TimesNote.size(); ++i)
	{
		NoteTime MyNote =(NoteTime)TimesNote.get(i);
		
		System.out.println("Ts="+String.valueOf(MyNote.Tstart));
		System.out.println("Te="+String.valueOf(MyNote.Tend));
		System.out.println("Note="+MyNote.Note);
	}
}
public SolControl(ArrayList Note)
{
		MyNoteTimes=Note2NoteTime(Note);
}

public void CalculateAverage()
{
	for(int i=0;i<ReportList.size();++i)
	{
		Average+=((NoteReport)ReportList.get(i)).percentage;
	}
	Average/=ReportList.size();
	
	
	if(Average<=20)
	{
		MyMark=MyMarks[0];
		
		try
		{
			in = new FileInputStream(".//audio//bad.wav");
			as = new AudioStream(in); 
			AudioPlayer.player.start(as);            
		
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
		        
	}
	else if(Average>20 && Average<=40)
	{
		MyMark=MyMarks[1];
		
		try
		{
			in = new FileInputStream(".//audio//notenough.wav");
			as = new AudioStream(in); 
			AudioPlayer.player.start(as);            
		
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
	}
	else if(Average>40 && Average<=60)
	{
		MyMark=MyMarks[2];
		
		try
		{
			in = new FileInputStream(".//audio//enough.wav");
			as = new AudioStream(in); 
			AudioPlayer.player.start(as);            
		
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
	}
	else if(Average>60 && Average<=80)
	{
		MyMark=MyMarks[3];
		
		try
		{
			in = new FileInputStream(".//audio//good.wav");
			as = new AudioStream(in); 
			AudioPlayer.player.start(as);            
		
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
	}
	else if(Average>80 && Average<=100)
	{
		MyMark=MyMarks[4];
		
		try
		{
			in = new FileInputStream(".//audio//excellent.wav");
			as = new AudioStream(in); 
			AudioPlayer.player.start(as);            
		
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	
}

public int IsCorrectNote(long Ts, long Te, String Note)
{
	NoteTime NoteDuration=null;
	int percentual_correct=0;
	float numeratore;
	
	for(int i=MyLastIndexFound;i<MyNoteTimes.size();++i)
	{
		NoteDuration= (NoteTime)MyNoteTimes.get(i);
		
	
		//Controllo sela nota premuta dall'utente sia compresa nel range + tolleranza
		if(Ts >= NoteDuration.Tstart-TOLLERANCE && Te <= NoteDuration.Tend+TOLLERANCE && Note.equals(NoteDuration.Note))
		{
			MyLastIndexFound=i+1;
			numeratore=Math.abs((Te-Ts)-(NoteDuration.Tend-NoteDuration.Tstart));
		
			if(numeratore == 0)
			{
				ReportList.add(new NoteReport(100,NoteDuration.Note));
				return 100;
			}
			else
			{
				percentual_correct=(int)((1.00-((float)(numeratore)/(float)(NoteDuration.Tend-NoteDuration.Tstart)))*100.00);
				ReportList.add(new NoteReport(percentual_correct,NoteDuration.Note));
				return percentual_correct;
			}
		}
		else
		{
			MyLastIndexFound=i+1;
			ReportList.add(new NoteReport(0,NoteDuration.Note));
			return 0;
		}		
	}
	
		
	return 0;
}
public void Init()
{
	MyLastIndexFound=0;
	ReportList=new ArrayList();
	MyMark="";

}
}