  import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 import java.io.*;

class ReportFrame extends JFrame
{
	
	myTable ReportTable;
	//dati in tabella
   	Object[][] data=null;
   	String [] columns=null;
	
	
	
	public ReportFrame(ArrayList ReportList)
	{
		
		columns=new String[]{"Note","Success Percentage"};
		
		PopolateData(ReportList);
		this.setResizable(false);
		AddJTable();
		
	}
	
	
	private void PopolateData(ArrayList ReportList)
	{
		data=new Object[ReportList.size()][2];
		for(int i=0;i < ReportList.size();++i)
		{
			SolControl.NoteReport usernote=(SolControl.NoteReport)ReportList.get(i);
			data[i][0]=usernote.note;
			data[i][1]=usernote.percentage;
		}
	}
	public static void launch(final JFrame f,String title)
    {
    	f.setTitle(title);
    	
    	f.setVisible(true);
    
    	f.addWindowListener(new WindowAdapter(){
    		public void windowClosed(WindowEvent e)
    		{
    			f.setVisible(false);
  
    		
    		}
    	});
  		 	
    }
    
    void AddJTable()
	{
		ReportTable=new myTable(data,columns);
		ReportTable.setEnabled(false);
		ReportTable.setRowHeight(20);
		ReportTable.setGridColor(Color.gray);
	
		
		JScrollPane sp=new JScrollPane();
		sp.getViewport().setView(ReportTable);
		sp.setPreferredSize(new Dimension(400, 300));

		
		JPanel p=new JPanel();
		p.add(sp,BorderLayout.SOUTH);
		
		this.getContentPane().add(p,BorderLayout.SOUTH);
		
		pack();
	
	}
    
    
    
    //Classe personalizzata che non permette l'editing sulle celle
	public class myTable extends JTable
	{
		public myTable(Object [][] cell,Object [] title)
		{
			
			super(cell,title);
		}
		

		public boolean isCellEditable(int row, int column) 
 		{
 			return false;
 		}
		
	}
}